// iter23.cpp
// list the lines of the probability table

#include "tree23.hpp"
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

extern int printtypes;

int main(int argc, char *argv[])
{
  if (argc < 2) {
    cout << "Usage: iter23 levels [0=normal, 1=types, 2=counttypes]\n";
    return 1;
  }

  int levels = atoi(argv[1]);
  if (levels > 3) {
    cout << "Can't do more than 3 yet.\n";
    return 1;
  }

  if (argc >= 3)
    printtypes = atoi(argv[2]);
  else
    printtypes = 0;

  treehandle thetree;
  thetree.set(0, levels);

  if (printtypes != 2) {
    cout << types(levels) << endl;
    do
      printcharacteristics(thetree);
    while (thetree++);
    cout << "-1\n";
  }
  else {
    int i=0;
    do {
      cout << setw(3) << i++ << "  " << thetree.gettype();
      int x = thetree.gettree()->countnodes();
      cout << "  Nodes=" << x;
      cout << "  Leaves@" << (x+1);
      cout << endl;
    } while (thetree++);
  }

  return 0;
}
