// random23.cpp
// creates random 2-3 trees and calculates nodes/keys

#include "tree23.hpp"
#include "slist.hpp"
#include <iostream.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>

inline int myrandom(int maxPlusOne)
{
  return rand() % maxPlusOne;
}

int main(int argc, char *argv[])
{
  int keys, trees;
  time_t t;

    srand((unsigned) time(&t));
//    randomize();

  if (argc >= 3) {
    keys = atoi(argv[1]);
    trees = atoi(argv[2]);
  }
  else {
    cout << "2-3 Tree Randomizer!\n";

    cout << "Number of keys: ";
    cin >> keys;
    if (keys <= 0)
      return 0;

    cout << "Trees to simulate: ";
    cin >> trees;
  }

  while (trees--) {

    tree23 *t = maketree(myrandom(keys*2));

    for(int i=1; i<keys; i++)
      t = insert(t, myrandom(keys*2));

    // tabulate the node count and kill the tree
    cout << tree23::count << endl;
    destroy(t);
  }

  return 0;
}
