// STRING.CPP
// Code for STRING.HPP

#include "string.hpp"
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>


int string::count=0;
int string::pchar_count=0;

void string::dup(char *src)
{
  if (!src)
    s = 0;
  else {
    s = new char[ strlen(src) + 1];
    pchar_count++;
    assert(s);
    strcpy(s, src);
  }
}

void string::kill()
{
  if (s) {
    pchar_count--;
    delete s;
  }
}


int string::toInt()
{
  assert(s);
  return atoi(s);
}

long string::toLong()
{
  assert(s);
  return atol(s);
}

float string::toFloat()
{
  assert(s);
  char *dummy;
  return strtod(s, &dummy);
}

double string::toDouble()
{
  assert(s);
  char *dummy;
  return strtod(s, &dummy);
}


string &string::fromchar(char single)
{
  kill();
  char temp[2] = "x";
  temp[0] = single;
  dup(temp);
  return *this;
}


string &string::fromint(long val)
{
  kill();
  char temp[15];
  //ltoa(val, temp, 10);
  // unix doesn't have ltoa...
  sprintf(temp, "%ld", val);
  dup(temp);
  return *this;
}

string &string::fromfloat(double val)
{
  kill();
  char temp[15];
  sprintf(temp, "%g", val);
  dup(temp);
  return *this;
}


string &string::setlength(int length)
{
  kill();
  s = new char[ length+1 ];
  pchar_count++;
  assert(s);
  s[length] = 0;
  return *this;
}


string string::operator+(string &tail)
{
  string dest;
  pchar_count++;
  dest.s = new char[ length() + tail.length() + 1 ];
  assert(dest.s);
  dest[0] = 0;
  if (s) strcpy(dest.s, s);
  if (tail.s) strcat(dest.s, tail.s);
  return dest;
}

string& string::operator+=(string &tail)
{
  pchar_count++;
  char *d = new char[ length() + tail.length() + 1];
  assert(d);
  d[0] = 0;
  if (s) strcpy(d, s);
  if (tail.s) strcat(d, tail.s);
  return *this;
}


istream& string::readline(istream &is)
{
  char buf[200];
  is.getline(buf, 199);
  operator= (buf);
  return is;
}


istream& string::readword(istream &is)
{
  char buf[200];
  int i=1;

  is >> buf[0];     // will skip initial whitespace
  while (i<199 && !isspace(is.peek()))
    buf[i++] = is.get();
  buf[i] = 0;

  operator= (buf);
  return is;
}


ostream& string::write(ostream &os)
{
  return os << pchar();     // standard char* writing routine
}
