// MY_TIMER.CC (unix verison) v1.00
// - Scott McPeak, November 1994
// Provides a simple timing mechanism which, through use of a standard
// header, MY_TIMER.H, can be used under DOS and UNIX

#include <sys/time.h>
#include <unistd.h>

static struct timeval starttimeval;
static struct timezone starttimezone;    // not really used

void my_timer_start()
{
  gettimeofday(&starttimeval, &starttimezone);
}


double my_timer_seconds()
{
  static struct timeval nowtv;
  static struct timezone nowtz;

  gettimeofday(&nowtv, &nowtz);
  return (double)(nowtv.tv_sec  - starttimeval.tv_sec)
       + (double)(nowtv.tv_usec - starttimeval.tv_usec) / 1000000.0;
}

